#include <bits/stdc++.h>
typedef int_fast64_t lli;
using namespace std;
signed main() 
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string s;
    cin >> s;
    vector<lli> ans(s.size(), 1e5);
    for(lli i = 0; i < s.size(); i++)
        for(lli j = i+1; j < s.size(); j++) 
            if(s[j-1] > s[j]) {ans[i] = j; break;}
    lli q;
    cin >> q;
    //for(lli i = 0; i < ans.size(); i++) cout << ans[i] << " ";
    //cout << endl;
    while(q--)
    {
        lli a, b, c = 0;
        cin >> a >> b, a--, b--;
        while(a <= b)
        {
            c++;
            a = ans[a];
            if(a == 1e5) {c++; break;}
        }
        cout << c << endl;
    }     
}
